// for Apple Pi
// (C)Copyright 2015 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/i2c-dev.h>

#define SLAVE_ADDRESS	0x3e
#define	filename	"/dev/i2c-1"


int i2c_write(int i2c, unsigned char a)
{
	unsigned char buf[2];
	buf[0]=0;
	buf[1]=a;
	return write(i2c,buf,2);
}


int main()
{

	int	i2c;
	int	i;
	unsigned char init1[]={ 0x38, 0x39, 0x14, 0x70, 0x56, 0x6c };
	unsigned char init2[]={ 0x38, 0x0c, 0x01 };
	

	if( (i2c=open(filename, O_RDWR)) <0 ){
		return 1;
	}

	if(ioctl(i2c, I2C_SLAVE, SLAVE_ADDRESS)<0){
		close(i2c);
		return 1;
	}

	// wait 100ms
	usleep(100000);

	for(i=0;i<6;i++){
		if(i2c_write(i2c, init1[i])!=2){
			close(i2c);
			exit(1);
		}
		usleep(50);
	}

	// wait 300ms
	usleep(300000);

	for(i=0;i<3;i++){
		if(i2c_write(i2c, init2[i])!=2){
			close(i2c);
			exit(1);
		}
		usleep(50);
	}
	
	close(i2c);
	return 0;

}


